<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="base-input2">
  <template>
    <style>
      :host {
        display: block;
      }
    </style>
     <p>[[currentValue]]</p>
    <fieldset>
      <label for="input">[[label]]</label>
      <input type="text" id="input"
      on-input="inputHandler"
      placeholder="[[placeholder]]"
      value="{{currentValue::input}}">
    </fieldset>
  </template>

  <script>
    /**
     * `base-input2`
     * 
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class BaseInput2 extends Polymer.Element {
      static get is() { return 'base-input2'; }
      static get properties() {
        return {
          label: {
            type: String,
            value: 'Input value'
          },
          placeholder:{
            type: String,
            value: 'Ingresa texto'
          },
          currentValue: {
            type: String,
            notify: true
          },
        };
      }

      inputHandler(e){
        console.log(e);
        this.dispatchEvent(new CustomEvent('custom-input',{
          bubbles: true,
          composed: true
        }));
      }

      constructor(){
        super();
        this.addEventListener('current-value-changed',(e) =>{
          console.log('evento lanzado con la propiedad \'current-value-changed\'', e);
        });
      }

    }

    window.customElements.define(BaseInput2.is, BaseInput2);
  </script>
</dom-module>
